#include <pthread.h>
#include <stdio.h>

struct arguments {
  int start;
  int end;
  int retval;
};

int square_adder (int start, int end) {
  int i;
  int sum = 0;
  for (i = start; i < end; i++) {
    sum += i * i;
  }
  return sum;
} 

void *thread_function (void *p) {
  int res;
  struct arguments *args;
  args = (struct arguments *) p;
  res = square_adder (args->start, args->end);
  args->retval = res;
}   

int main () {
  // Loesung mit Threads
  pthread_t t1, t2;
  struct arguments a1, a2;
  a1.start = 1;
  a1.end   = 51;
  a2.start = 51;
  a2.end   = 101;
  pthread_create (&t1, NULL, thread_function, &a1);
  pthread_create (&t2, NULL, thread_function, &a2);
  pthread_join (t1, NULL);
  pthread_join (t2, NULL);
  printf ("t1 returns %d\n", a1.retval);
  printf ("t2 returns %d\n", a2.retval);
  printf ("total sum: %d\n", a1.retval + a2.retval);

  printf ("Kontrolle: %d\n", square_adder (1, 101));
}
